import { Injectable } from '@angular/core';
import { IObjectListUIService } from '@objects-view/interfaces/object-list-ui-service';
import { Router } from '@angular/router';
import { ConfigService } from '@shared/config/config.service';
import { IBaseFleioObjectModel } from '@fleio-api/base-model/base-fleio-object.model';
import { IPermissionsModel } from '@fleio-api/base-model/IPermissionsModel';
import { IObjectUIService } from '@objects-view/interfaces/object-ui-service';
import { FleioObjectsList } from '@fleio-api/fleio-objects-list';
import { ITableData } from '@objects-view/interfaces/table-data/table-data';
import { ColumnType } from '@objects-view/interfaces/table-data/column-definition';
import { ITableRow } from '@objects-view/interfaces/table-data/table-row';
import { IAction } from '@objects-view/interfaces/actions/action';
import { RouterLinkAction } from '@objects-view/actions/router-link-action';
import { ConfigurationsApiService } from '@fleio-api/configurations/configurations-api.service';
import { ConfigurationUiService } from './configuration-ui.service';
import { IConfigurationModel } from '@fleio-api/configurations/model/configuration.model';

@Injectable({
  providedIn: 'root'
})
export class ConfigurationListUIService implements IObjectListUIService {
  public noItemsMessage = $localize`No configurations`;

  constructor(
    private router: Router, private config: ConfigService,
    private configurationsApiService: ConfigurationsApiService,
  ) {
  }

  getObjectUIService(
    object: IBaseFleioObjectModel, permissions: IPermissionsModel, state: string
  ): IObjectUIService {
    return new ConfigurationUiService(
      object as IConfigurationModel, permissions, state, this.router, this.config, this.configurationsApiService,
    );
  }

  getTableData(objectList: FleioObjectsList<IConfigurationModel>): ITableData {
    const tableData: ITableData = {
      header: {
        columns: [
          {type: ColumnType.Value, displayName: $localize`Name`, enableSort: true, fieldName: 'name', flexXs: '1 0 50px'},
          {type: ColumnType.Value, displayName: $localize`Labels`, enableSort: false, fieldName: 'tags'},
          {
            type: ColumnType.Value, displayName: $localize`Description`, enableSort: false, fieldName: 'description',
            flex: '50', hide: {xs: true},
          },
          {type: ColumnType.Actions, displayName: $localize`Actions`, enableSort: false, fieldName: '(actions)'},
        ],
        columnNames: ['name', 'tags', 'description', '(actions)'],
        showStatus: true,
      },
      rows: [],
    };

    for (const configuration of objectList.objects) {
      const rowUIService = this.getObjectUIService(configuration, objectList.permissions, 'table-view');
      const row: ITableRow = {
        cells: {
          name: {text: configuration.name},
          tags: {tags: rowUIService.getCardTags()},
          description: {text: configuration.description},
        },
        icon: rowUIService.getIcon(),
        status: rowUIService.getStatus(),
        actions: rowUIService.getActions(),
        url: rowUIService.getDetailsLink(),
        object: configuration,
      };

      tableData.trackByFunction = (index, item: ITableRow) => item.object.id;
      tableData.rows.push(row);
    }

    return tableData;
  }

  getActions(objectList: FleioObjectsList<IBaseFleioObjectModel>): IAction[] {
    return [
      new RouterLinkAction({
        name: $localize`Create new configuration`,
        tooltip: $localize`Create new configuration`,
        icon: {name: 'add'},
        router: this.router,
        routerUrl: this.config.getPanelUrl('settings/configurations/create'),
        noPermissions: !objectList.permissions['configurations.create'],
      })
    ];
  }

  getRefreshInterval(): number {
    if (this.config && this.config.current && this.config.current.settings &&
      this.config.current.settings.refreshIntervals) {
      return this.config.current.settings.refreshIntervals.defaultInterval;
    }
    return 10000;
  }
}
